/*
|   This program prints labels for diskettes on an HP LaserJet II
|   or equivalent printer.  Written by Bill Jackson, CIS 71571,1234 
|   and dedicated to the public domain as freeware on November 22, 1989.
|   This source code calls OS/2 functions and must be compiled under
|   OS/2, although all are FAPI's and the program can be bound to run  
|   in real mode or under DOS as well as in protected mode.
|   As currently written, the program will list only the files in the
|   current directory for drive A when run in real (DOS) mode.  In
|   OS/2 protected mode, however, it will also recursively process
|   subdirectories and list files for as many subdirectory levels as
|   available label space permits.
+--------------------------------------------------------------------------*/

#define INCL_BASE
#include <OS2.H>
#include <stdio.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <io.h>
  
#define SUBDIR_MASK 0x10
extern void main(int argc, char **argv);
extern void lbl_hp_line_printer (FILE *print_pointer);
extern void lbl_hp_set_cursor (FILE *print_pointer, USHORT row, USHORT column);
extern void list_dir (char *directory, USHORT level);
extern void lbl_hp_courier_bold (FILE *print_pointer);
  
/* global variables */
  
FILE *print_pointer;
USHORT lp_label_base_column = 0;
USHORT lp_label_base_row = 0;
USHORT cb_label_base_column = 0;
USHORT cb_label_base_row = 0;
USHORT label_type = 0;
USHORT label_file_number = 0;
USHORT sheet_column = 0;
USHORT sheet_row = 0;
USHORT label_number = 0;
  
void main(int argc, char **argv)
{
    USHORT          cbDirPath;
    USHORT          done = FALSE;
    USHORT          level = 0;
    KBDKEYINFO      kbciKeyInfo;
    int             print_handle;
    CHAR            szDirPath[255];
    ULONG           ulLogicalDrives;
    USHORT          usDisk;
    char            user_input[80];
    USHORT          valid_code = FALSE;

  
    cbDirPath = sizeof (szDirPath);
    DosQCurDisk (&usDisk, &ulLogicalDrives);
    DosQCurDir (usDisk, (PBYTE)szDirPath, &cbDirPath);

    printf ("\n           HPDLBL Version 1.0\n\n");
    printf ("This program prints diskette labels on a Hewlett-Packard\n");
    printf ("LaserJet II or compatible laser printer using Hewlett-Packard\n");
    printf ("3.5 Inch Diskette Labels (HP 92296H) or 5.25 Inch Diskette\n");
    printf ("Labels (HP 92296J) or equivalent\n\n");
    printf ("In real (DOS) mode this program will print all filnames in \n");
    printf ("the currently active directory for Drive A.  In OS/2 protected\n");
    printf ("mode subdirectories will also be expanded.\n\n");
    printf ("This program processes optional command line parameters\n");
    printf ("       HPDLBL disksize startlabelnumber \n");
    printf ("where disksize is 3 or 5 and startlabelnumber is between\n");
    printf ("1 and the maximum number of labels on the page (9 or 12)\n\n");

  
    valid_code = FALSE;

    if (argc > 1)
        switch (argv[1][0])
        {
            case '3':
                label_type = 3;
                valid_code = TRUE;
                break;
            case '5':
                label_type = 5;
                valid_code = TRUE;
                break;
            default:
                valid_code = FALSE;
                printf ("\nINVALID COMMAND LINE PARAMETER IGNORED.\n");
        }
             
    while (!(valid_code))
    {
        printf ("\n\nEnter 3 for 3.5\" diskettes or 5 for 5.25\" diskettes -> ");
        KbdCharIn (&kbciKeyInfo, IO_WAIT, 0);
        printf ("%c", kbciKeyInfo.chChar);
        switch (kbciKeyInfo.chChar)
        {
            case '3':
                label_type = 3;
                valid_code = TRUE;
                break;
            case '5':
                label_type = 5;
                valid_code = TRUE;
                break;
            default:
                valid_code = FALSE;
                printf ("\nINVALID ENTRY; valid choices are 3 and 5.\n");
        }
  
    }
  
    valid_code = FALSE;

    if (argc > 2)
    {
        switch (argv[2][0])
        {
            case '1':
            switch (argv[2][1])
            {
                case '0':
                    label_number = 9;
                    break;
                case '1':
                    label_number = 10;
                    break;
                case '2':
                    label_number = 11;
                    break;
                default:
                    label_number = 0;
            }
                valid_code = TRUE;
                break;
            case '2':
                label_number = 1;
                valid_code = TRUE;
                break;
            case '3':
                label_number = 2;
                valid_code = TRUE;
                break;
            case '4':
                label_number = 3;
                valid_code = TRUE;
                break;
            case '5':
                label_number = 4;
                valid_code = TRUE;
                break;
            case '6':
                label_number = 5;
                valid_code = TRUE;
                break;
            case '7':
                label_number = 6;
                valid_code = TRUE;
                break;
            case '8':
                label_number = 7;
                valid_code = TRUE;
                break;
            case '9':
                label_number = 8;
                valid_code = TRUE;
                break;
            default:
                valid_code = FALSE;
        }
        if ((label_type == 3) && (label_number > 8))
            valid_code = FALSE;
        if (valid_code == FALSE)
            printf ("\nINVALID COMMAND LINE PARAMETER IGNORED\n");
  
    }
    while (!(valid_code))
    {
        printf ("\n\nLabels on a sheet are numbered by positions 1 through ");
        if (label_type == 3)
            printf ("9.\n");
        else
            printf ("12.\n");
        printf ("Default setting starts at label 1.  If you wish to start\n");
        printf ("at a different label, enter the number -> ");
        KbdCharIn (&kbciKeyInfo, IO_WAIT, 0);
        printf ("%c", kbciKeyInfo.chChar);
        user_input[0] = (char)kbciKeyInfo.chChar;
        if ((label_type == 5) && (kbciKeyInfo.chChar == '1'))
        {
            KbdCharIn (&kbciKeyInfo, IO_WAIT, 0);
            printf ("%c", kbciKeyInfo.chChar);
            user_input[1] = (char)kbciKeyInfo.chChar;
        }
        switch (user_input[0])
        {
            case '1':
            switch (user_input[1])
            {
                case '0':
                    label_number = 9;
                    break;
                case '1':
                    label_number = 10;
                    break;
                case '2':
                    label_number = 11;
                    break;
                default:
                    label_number = 0;
            }
                valid_code = TRUE;
                break;
            case '2':
                label_number = 1;
                valid_code = TRUE;
                break;
            case '3':
                label_number = 2;
                valid_code = TRUE;
                break;
            case '4':
                label_number = 3;
                valid_code = TRUE;
                break;
            case '5':
                label_number = 4;
                valid_code = TRUE;
                break;
            case '6':
                label_number = 5;
                valid_code = TRUE;
                break;
            case '7':
                label_number = 6;
                valid_code = TRUE;
                break;
            case '8':
                label_number = 7;
                valid_code = TRUE;
                break;
            case '9':
                label_number = 8;
                valid_code = TRUE;
                break;
            case '\r':
                label_number = 0;
                valid_code = TRUE;
                break;
            default:
                valid_code = FALSE;
        }
        if ((label_type == 3) && (label_number > 8))
            valid_code = FALSE;
        if (valid_code == FALSE)
            printf ("\nINVALID ENTRY.\n");
  
    }
    print_handle = open ("PRN", O_WRONLY);               /* open file handle */
    if (print_handle == -1)                           /* test for open error */
        perror ("open failed on PRN");
    print_pointer = fdopen (print_handle, "w");          /* associate stream */
    if (print_pointer == NULL)                             /* test for error */
        perror ("fopen failed on print_handle");
    fprintf (print_pointer, "\x01BE");                 /* send Esc E (reset) */
    fprintf (print_pointer, "\x01B&l0O");  /* set portrait orientation */
    fprintf (print_pointer, "\x01B&l8D");    /* 8 lpi line spacing */
    fprintf (print_pointer, "\x01B&l88P");   /* set 88 line page length */
    fprintf (print_pointer, "\x01B&l80F");   /* set 80 line text length */
    fprintf (print_pointer, "\x01B&l0L");   /* disable skip perf */
    fprintf (print_pointer, "\x01B&l0E");    /* 0 lines top margin */
    fprintf (print_pointer, "\x01B&a0L");    /* 0 column left margin */
    fprintf (print_pointer, "\x01B&a142M");  /* colum 142 right margin */
    fprintf (print_pointer, "\x01B&a0C");    /* position cursor at column 0 */
    fprintf (print_pointer, "\x01B&a0R");    /* position cursor at row 0 */
  
    while (!(done))
    {
        label_file_number = 0;
        label_number++;
        printf ("\nEnter diskette for Label in drive A \n");
        printf ("Hit return/enter when ready.");
        gets(user_input);
        list_dir (".", level);
        printf ("Completed Label Number %d\n", label_number);
        if (((label_type == 3) && (label_number >= 9))
            ||
            ((label_type == 5) && (label_number >= 12)))
        {
            done = TRUE;
            break;
        }
        printf ("\nDo you want to print another label? (Y/N) -> ");
        KbdCharIn (&kbciKeyInfo, IO_WAIT, 0);
        printf ("%c", kbciKeyInfo.chChar);
        if ((kbciKeyInfo.chChar == 'N') || (kbciKeyInfo.chChar == 'n'))
            done = TRUE;
        else
            done = FALSE;
    }
    fprintf (print_pointer,"\f");
    fprintf (print_pointer, "\x01BE");                 /* send Esc E (reset) */
    if (fclose (print_pointer) == EOF)                       /* close stream */
        perror ("fclose failed on print_pointer");          /* test for error */
    DosSelectDisk (usDisk);
    DosChdir (szDirPath, 0L);
    printf ("\nThis program is public domain freeware written by \n");
    printf ("Bill Jackson, CIS 71571,1234.  Comments and suggstions \n");
    printf ("are welcomed.\n");
  
}
  
void list_dir (char *directory, USHORT level)
{
    BYTE            bMode;
    USHORT          count;
    USHORT          error_number = 0;
    FILEFINDBUF     findbuf;
    HDIR            hdir = 0xFFFF;
    USHORT          usAttribute = 0x0037;
    USHORT          usDriveNumber = 1;
    USHORT          usSearchCount = 1;
    char            volume_in[80];
    struct {
        FDATE       fdateCreation;
        FTIME       ftimeCreation;
        CHAR        cchName;
        CHAR        achVolumeName[14];
    }               FSInfoBuf;
    struct {
        UCHAR       volid_len;
        char        volid[13];
    }               setFSInfoBuf;
  
    DosGetMachineMode (&bMode);
    if(bMode)
        hdir = 0xFFFF;
    else
        hdir = 0x0001;
    if (label_file_number == 0)
    {
        switch (label_number)
        {
            case 1:
                if (label_type == 3)
                {
                    lp_label_base_column = 0;
                    lp_label_base_row = 5;
                    cb_label_base_column = 0;
                    cb_label_base_row = 5;
                }
                else
                {
                    lp_label_base_column = 0;
                    lp_label_base_row = 8;
                    cb_label_base_column = 0;
                    cb_label_base_row = 8;
                }
                break;
            case 2:
                if (label_type == 3)
                {
                    lp_label_base_column = 46;
                    lp_label_base_row = 5;
                    cb_label_base_column = 27;
                    cb_label_base_row = 5;
                }
                else
                {
                    lp_label_base_column = 70;
                    lp_label_base_row = 8;
                    cb_label_base_column = 42;
                    cb_label_base_row = 8;
                }
                break;
            case 3:
                if (label_type == 3)
                {
                    lp_label_base_column = 92;
                    lp_label_base_row = 5;
                    cb_label_base_column = 55;
                    cb_label_base_row = 5;
                }
                else
                {
                    lp_label_base_column = 0;
                    lp_label_base_row = 20;
                    cb_label_base_column = 0;
                    cb_label_base_row = 20;
                }
                break;
            case 4:
                if (label_type == 3)
                {
                    lp_label_base_column = 0;
                    lp_label_base_row = 29;
                    cb_label_base_column = 0;
                    cb_label_base_row = 29;
                }
                else
                {
                    lp_label_base_column = 70;
                    lp_label_base_row = 20;
                    cb_label_base_column = 42;
                    cb_label_base_row = 20;
                }
                break;
            case 5:
                if (label_type == 3)
                {
                    lp_label_base_column = 46;
                    lp_label_base_row = 29;
                    cb_label_base_column = 27;
                    cb_label_base_row = 29;
                }
                else
                {
                    lp_label_base_column = 0;
                    lp_label_base_row = 32;
                    cb_label_base_column = 0;
                    cb_label_base_row = 32;
                }
                break;
            case 6:
                if (label_type == 3)
                {
                    lp_label_base_column = 92;
                    lp_label_base_row = 29;
                    cb_label_base_column = 55;
                    cb_label_base_row = 29;
                }
                else
                {
                    lp_label_base_column = 70;
                    lp_label_base_row = 32;
                    cb_label_base_column = 42;
                    cb_label_base_row = 32;
                }
                break;
            case 7:
                if (label_type == 3)
                {
                    lp_label_base_column = 0;
                    lp_label_base_row = 53;
                    cb_label_base_column = 0;
                    cb_label_base_row = 53;
                }
                else
                {
                    lp_label_base_column = 0;
                    lp_label_base_row = 44;
                    cb_label_base_column = 0;
                    cb_label_base_row = 44;
                }
                break;
            case 8:
                if (label_type == 3)
                {
                    lp_label_base_column = 46;
                    lp_label_base_row = 53;
                    cb_label_base_column = 27;
                    cb_label_base_row = 53;
                }
                else
                {
                    lp_label_base_column = 70;
                    lp_label_base_row = 44;
                    cb_label_base_column = 42;
                    cb_label_base_row = 44;
                }
                break;
            case 9:
                if (label_type == 3)
                {
                    lp_label_base_column = 92;
                    lp_label_base_row = 53;
                    cb_label_base_column = 55;
                    cb_label_base_row = 53;
                }
                else
                {
                    lp_label_base_column = 0;
                    lp_label_base_row = 56;
                    cb_label_base_column = 0;
                    cb_label_base_row = 56;
                }
                break;
            case 10:
                lp_label_base_column = 70;
                lp_label_base_row = 56;
                cb_label_base_column = 42;
                cb_label_base_row = 56;
                break;
            case 11:
                lp_label_base_column = 0;
                lp_label_base_row = 68;
                cb_label_base_column = 0;;
                cb_label_base_row = 68;
                break;
            case 12:
                lp_label_base_column = 70;
                lp_label_base_row = 68;
                cb_label_base_column = 42;
                cb_label_base_row = 68;
                break;
        }
  
        lbl_hp_courier_bold (print_pointer);
        DosSelectDisk(usDriveNumber);
        error_number = DosQFSInfo(usDriveNumber,2,(PBYTE) &FSInfoBuf,
            sizeof(FSInfoBuf));
        if (error_number)
            strcpy (FSInfoBuf.achVolumeName, "");
        if ((strcmp (FSInfoBuf.achVolumeName, "")) == 0)
        {
            printf ("\nVolume has no label.  Enter label -> ");
            gets (volume_in);
            volume_in[11] = '\0';
            strcpy (setFSInfoBuf.volid, volume_in);
            setFSInfoBuf.volid_len = (UCHAR) strlen (setFSInfoBuf.volid);
            if (setFSInfoBuf.volid_len)
                error_number = DosSetFSInfo (usDriveNumber, 2,
                    (PBYTE) &setFSInfoBuf, sizeof (setFSInfoBuf));
            else
                error_number = 0;
            if (error_number)
                switch (error_number)
                {
                    case ERROR_CANNOT_MAKE:
                        printf ("\nError Cannot Make\n");
                        break;
                    case ERROR_INSUFFICIENT_BUFFER:
                        printf ("\nError INSUFFICIENT BUFFER\n");
                        break;
                    case ERROR_INVALID_DRIVE:
                        printf ("\nError INVALID DRIVE\n");
                        break;
                    case ERROR_INVALID_LEVEL:
                        printf ("\nError INVALID LEVEL\n");
                        break;
                    case ERROR_INVALID_NAME:
                        printf ("\nError INVALID_NAME\n");
                        break;
                    case ERROR_LABEL_TOO_LONG:
                        printf ("\nError LABEL TOO LONG\n");
                        break;
                    default:
                        printf ("\nUnknown error\n");
                    }
            DosQFSInfo(usDriveNumber,2,(PBYTE) &FSInfoBuf, sizeof(FSInfoBuf));
        }
        if (label_type == 3)
        {
            sheet_column = cb_label_base_column + 6;
            sheet_row = cb_label_base_row;
            lbl_hp_set_cursor (print_pointer, sheet_row, sheet_column);
            fprintf (print_pointer,"%s", FSInfoBuf.achVolumeName);
            sheet_row = sheet_row + 19;
            lbl_hp_set_cursor (print_pointer, sheet_row, sheet_column);
            fprintf (print_pointer,"%s", FSInfoBuf.achVolumeName);
            lbl_hp_line_printer (print_pointer);
            sheet_column = lp_label_base_column;
            sheet_row = lp_label_base_row + 2;
        }
        if (label_type == 5)
        {
            sheet_column = cb_label_base_column + 13;
            sheet_row = cb_label_base_row + 1;
            lbl_hp_set_cursor (print_pointer, sheet_row, sheet_column);
            fprintf (print_pointer,"%s", FSInfoBuf.achVolumeName);
            lbl_hp_line_printer (print_pointer);
            sheet_column = lp_label_base_column + 2;
            sheet_row = lp_label_base_row + 3;
        }
        lbl_hp_set_cursor (print_pointer, sheet_row, sheet_column);
    }
    if (strcmp (directory, "."))
    {
        if ((label_type == 3) && (level < 2))
            level++;
        if ((label_type == 5) && (level < 3))
            level++;
    }
    DosChdir(directory, 0L);
  
    error_number = DosFindFirst ("*.*", &hdir, usAttribute, &findbuf,
        sizeof(findbuf), &usSearchCount, 0L);
    if (error_number)
        switch (error_number)
        {
            case ERROR_DRIVE_LOCKED:
                printf ("\nDosFindFirst Error DRIVE LOCKED\n");
                break;
            case ERROR_FILE_NOT_FOUND:
                printf ("\nDosFindFirst Error FILE NOT FOUND\n");
                break;
            case ERROR_INVALID_HANDLE:
                printf ("\nDosFindFirst Error INVALID HANDLE\n");
                break;
            case ERROR_INVALID_PARAMETER:
                printf ("\nDosFindFirst Error INVALID PARAMETER\n");
                break;
            case ERROR_NO_MORE_FILES:
                printf ("\nDosFindFirst Error NO MORE FILES\n");
                break;
            case ERROR_NO_MORE_SEARCH_HANDLES:
                printf ("\nDosFindFirst Error NO MORE SEARCH HANDLES\n");
                break;
            case ERROR_NOT_DOS_DISK:
                printf ("\nDosFindFirst Error NOT DOS DISK\n");
                break;
            case ERROR_PATH_NOT_FOUND:
                printf ("\nDosFindFirst Error PATH NOT FOUND\n");
                break;
            default:
                printf ("\nDosFindFirst Unknown error\n");
        }
     do{
        if ((strcmp (".", findbuf.achName)) && (strcmp ("..",findbuf.achName)))
        {
            if (label_type == 3)
            {
                if (label_file_number == 39)
                    return;
                if ((label_file_number == 13) || (label_file_number == 26))
                {
                    sheet_column = sheet_column + 14;
                    sheet_row = lp_label_base_row + 2;
                }
            }
            if (label_type == 5)
            {
                if (label_file_number == 32)
                    return;
                if ((label_file_number == 8)
                    || (label_file_number == 16)
                    || (label_file_number == 24))
                {
                    sheet_column = sheet_column + 15;
                    sheet_row = lp_label_base_row + 3;
                }
            }
            lbl_hp_set_cursor (print_pointer, sheet_row, sheet_column);
            for (count = 0; count < level; count++)
                fprintf (print_pointer, " ");
            fprintf (print_pointer, "%s", findbuf.achName);
            label_file_number++;
            if (findbuf.attrFile & SUBDIR_MASK)
            {
                fprintf (print_pointer, "\\");
                sheet_row++;
                if (bMode)
                    list_dir (findbuf.achName, level);
            }
            else
                sheet_row++;
        }
  
    }
    while (!(error_number = DosFindNext (hdir, &findbuf, sizeof(findbuf),
        &usSearchCount)));
    if (error_number)
        switch (error_number)
        {
            case ERROR_DRIVE_LOCKED:
                printf ("\nDosFindNext Error DRIVE LOCKED\n");
                break;
            case ERROR_FILE_NOT_FOUND:
                printf ("\nDosFindNext Error FILE NOT FOUND\n");
                break;
            case ERROR_INVALID_HANDLE:
                printf ("\nDosFindNext Error INVALID HANDLE\n");
                printf ("\nhdir = %lx\n", hdir);
                break;
            case ERROR_INVALID_PARAMETER:
                printf ("\nDosFindNext Error INVALID PARAMETER\n");
                break;
            case ERROR_NO_MORE_FILES:
                /* NO MORE FILES is expected termination of search */
                break;
            case ERROR_NO_MORE_SEARCH_HANDLES:
                printf ("\nDosFindNext Error NO MORE SEARCH HANDLES\n");
                break;
            case ERROR_NOT_DOS_DISK:
                printf ("\nDosFindNext Error NOT DOS DISK\n");
                break;
            case ERROR_PATH_NOT_FOUND:
                printf ("\nDosFindNext Error PATH NOT FOUND\n");
                break;
            default:
                printf ("\nDosFindNext Unknown error\n");
        }
     if (strcmp (directory, "."))
        DosChdir("..", 0L);
     DosFindClose (hdir);
}
   
  
void lbl_hp_set_cursor (print_pointer, row, column)
FILE *print_pointer;
USHORT row;
USHORT column;
{
    char row_command[80];
    char column_command[80];
    char num_string[80];
  
    strcpy (row_command, "\x01B&a");
    itoa ((int) row, num_string, 10);
    strcat (row_command, num_string);
    strcat (row_command, "R");
    fprintf (print_pointer, row_command);
  
    strcpy (column_command, "\x01B&a");
    itoa (((int) column), num_string, 10);
    strcat (column_command, num_string);
    strcat (column_command, "C");
    fprintf (print_pointer, column_command);
  
}
  
  
  
  
void lbl_hp_line_printer (print_pointer)
FILE *print_pointer;
{
    fprintf (print_pointer,
    "\x01B&l0O"                                      /* portrait orientation */
    "\x01B(10U"                                           /* PC-8 Symbol Set */
    "\x01B(s0P"                                             /* fixed spacing */
    "\x01B(s16.6H"                                         /* 16.6 cpi pitch */
    "\x01B(s8.5V"                                        /* 8.5 point height */
    "\x01B(s0S"                                             /* upright style */
    "\x01B(s0B"                                      /* medium stroke weight */
    "\x01B(s0T");                                   /* Line Printer typeface */
    /* balance parentheses for source code checker ))))))) */
  
}
  
  
void lbl_hp_courier_bold (print_pointer)
FILE *print_pointer;
{
    fprintf (print_pointer,
    "\x01B(10U"                                           /* PC-8 Symbol Set */
    "\x01B(s0P"                                             /* fixed spacing */
    "\x01B(s10H"                                         /* 10 cpi pitch */
    "\x01B(s12V"                                        /* 12 point height */
    "\x01B(s0S"                                             /* upright style */
    "\x01B(s3B"                                      /* bold stroke weight */
    "\x01B(s3T");                                /* Courier Printer typeface */
    /* balance parentheses for source code checker ))))))) */
  
}
  
